require 'torgi_gov/request/load_notification'

module TorgiGov
  class BidKind1 < LoadNotification
    private

    def parse
      {
        number:       number,
        organization: organization,
        common:       common,
        docs:         docs,
        lots:         lots,
        protocol:     protocol
      }
    end

    def lots
      @body.css('notification lot').collect do |doc|
        {
          lotNum:             doc.css('lotNum').text,
          bidStatus:          doc.css('bidStatus name').text,
          propertyType:       doc.css('propertyType name').text,
          propKind:           doc.css('propKind name').text,
          location:           doc.css('location').text,
          article:            doc.css('article name').text,
          cancelDate:         doc.css('cancelDate').text,
          description:        doc.css('description').text,
          mission:            doc.css('mission').text,
          areaMeters:         doc.css('areaMeters').text,
          termYear:           doc.css('termYear').text,
          termMonth:          doc.css('termMonth').text,
          termDay:            doc.css('termDay').text,
          monthPrice:         doc.css('monthPrice').text,
          yearPrice:          doc.css('yearPrice').text,
          dealFee:            doc.css('dealFee').text,
          contractFee:        doc.css('contractFee').text,
          startPricePerMonth: doc.css('startPricePerMonth').text,
          depositSize:        doc.css('depositSize').text,
          isBurdened:         doc.css('isBurdened').text,
          burdenDescription:  doc.css('burdenDescription').text,
          isSubrent:          doc.css('isSubrent').text,
          contractDate:       doc.css('contractDate').text,
          contractPayment:    doc.css('contractPayment').text,
          contractPriceYear:  doc.css('contractPriceYear').text,
          contractPriceMonth: doc.css('contractPriceMonth').text,
          currency:           doc.css('currency').text,
          docs:               lot_docs
        }
      end
    end

    def lot_docs
      @body.css('notification lot documents').collect do |doc|
        {
          description: doc.css('description').text,
          created:     doc.css('created').text,
          docUrl:      doc.css('docUrl').text
        }
      end
    end
  end
end