require 'torgi_gov/request/load_notification'

module TorgiGov
  class BidKind2 < LoadNotification
    private

    def parse
      {
        number:       number,
        organization: organization,
        common:       common,
        docs:         docs,
        lots:         lots,
        protocol:     protocol,
        results:      results
      }
    end

    def lots
      @body.css('notification lot').collect do |doc|
        {
          lotNum:                 doc.css('lotNum').text,
          bidStatus:              doc.css('bidStatus name').text,
          cancelDate:             doc.css('cancelDate').text,
          cancelReason:           doc.css('cancelReason').text,
          suspendDate:            doc.css('suspendDate').text,
          suspendReason:          doc.css('suspendReason').text,
          bidType:                doc.css('bidType name').text,
          propKind:               doc.css('propKind name').text,
          cadastralNum:           doc.css('cadastralNum').text,
          mission:                doc.css('mission').text,
          kladrLocation:          doc.css('kladrLocation name').text,
          location:               doc.css('location').text,
          unit:                   doc.css('unit name').text,
          area:                   doc.css('area').text,
          description:            doc.css('description').text,
          termYear:               doc.css('termYear').text,
          termMonth:              doc.css('termMonth').text,
          article:                doc.css('name').text,
          pricePerMonth:          doc.css('pricePerMonth').text,
          pricePerYear:           doc.css('pricePerYear').text,
          startPrice:             doc.css('startPrice').text,
          startPriceAreaSm:       doc.css('startPriceAreaSm').text,
          step:                   doc.css('step').text,
          depositSize:            doc.css('depositSize').text,
          depositDesc:            doc.css('depositDesc').text,
          maintenanceSize:        doc.css('maintenanceSize').text,
          buildConditions:        doc.css('buildConditions').text,
          techConditions:         doc.css('techConditions').text,
          isBurdened:             doc.css('isBurdened').text,
          burdenDescription:      doc.css('burdenDescription').text,
          lotPhotosExist:         doc.css('lotPhotosExist').text,
          groundViewPlace:        doc.css('groundViewPlace').text,
          articleVal:             doc.css('articleVal').text,
          resultStartPriceAreaSm: doc.css('resultStartPriceAreaSm').text,
          bidResults:             doc.css('bidResults').text,
          winner:                 "#{doc.css('winner name').text} #{doc.css('winner inn').text}",
          currency:               doc.css('currency').text,
          currencyPercent:        doc.css('currencyPercent').text,          
          docs:                   lot_docs
        }
      end
    end

    def lot_docs
      @body.css('notification lot documents').collect do |doc|
        {
          description: doc.css('description').text,
          created:     doc.css('created').text,
          docUrl:      doc.css('docUrl').text
        }
      end
    end

    def results
      @body.css('results').collect do |doc|
        {
          regNum:         doc.css('bidMember regNum').text,
          name:           doc.css('bidMember name').text,
          inn:            doc.css('bidMember inn').text,
          kpp:            doc.css('bidMember kpp').text,
          ogrn:           doc.css('bidMember ogrn').text,
          location:       doc.css('bidMember location').text,
          phone:          doc.css('bidMember phone').text,
          isSelected:     doc.css('bidMember isSelected').text,
          refuseReason:   doc.css('bidMember refuseReason').text,
          tenderPosition: doc.css('bidMember tenderPosition').text,
          offer:          doc.css('bidMember offer').text,
        }
      end
    end

    def protocol
      @body.css('protocol').collect do |doc|
        {
          protocolType:         doc.css('protocolType').text,
          protocolNum:          doc.css('protocolNum').text,
          protocolTown:         doc.css('protocolTown').text,
          protocolDate:         doc.css('protocolDate').text,
          docprotocolPlaceUrl:  doc.css('protocolPlace').text,
          committee_name:       doc.css('committee member name').text,
          committee_role:       doc.css('committee member role').text,
          cancelReason:         doc.css('lot cancelReason').text,
          decision:             doc.css('lot decision').text
        }
      end
    end
  end
end